#include <jni.h>
#include <string>
#include <sstream>
#include <cstring>
#include "main.h"

using namespace std;

#define JNI2TEST(f, fn) \
extern "C" JNIEXPORT void JNICALL \
Java_com_lizardtech_lidarexample_LidarExample_##fn( JNIEnv* env, jobject thiz ) \
{ \
	try { f(); } \
	catch(Error &e) { \
		ostringstream message("Error: "); message << \
		e.filename() << ":" << \
		e.line() << ":" << \
		e.function() << ": " << \
		e.what() << "\n"; \
		jclass Exception = env->FindClass("java/lang/Exception"); \
		env->ThrowNew(Exception, message.str().c_str()); \
	} \
	catch(exception &e) { \
		ostringstream message("std::exception: "); message << e.what() << "\n"; \
		jclass Exception = env->FindClass("java/lang/Exception"); \
		env->ThrowNew(Exception, message.str().c_str()); \
	} \
	catch(...) { \
		jclass Exception = env->FindClass("java/lang/Exception"); \
		env->ThrowNew(Exception, "unknown exception\n"); \
	} \
}

jint JNI_OnLoad(JavaVM* vm, void* reserved)
{
    JNIEnv* env;
    if (vm->GetEnv(reinterpret_cast<void**>(&env), JNI_VERSION_1_6) != JNI_OK) {
        return -1;
    }

    return JNI_VERSION_1_6;
}

JNI2TEST(UserTutorial_iterator, UserTutorial_1iterator)
JNI2TEST(UserTutorial_read, UserTutorial_1read)
JNI2TEST(DumpMG4Info, DumpMG4Info)
JNI2TEST(IterateOverPoints, IterateOverPoints)
JNI2TEST(DecodeMG4ToTXT, DecodeMG4ToTXT)
JNI2TEST(DecodeMrSIDRaster, DecodeMrSIDRaster)
JNI2TEST(UserTest, UserTest)
