package com.lizardtech.lidarexample;

import android.app.Activity;
import android.widget.TextView;
import android.os.Bundle;


public class LidarExample extends Activity
{
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        
        // Call the various SDK tests and report the results
        boolean allPassed = true;
        StringBuilder testResults = new StringBuilder();

        try {
	        testResults.append("Ran UserTutorial_iterator\n"); UserTutorial_iterator();
	        testResults.append("Ran UserTutorial_read\n"); UserTutorial_read();
	        testResults.append("Ran DumpMG4Info\n"); DumpMG4Info();
	        testResults.append("Ran IterateOverPoints\n"); IterateOverPoints();
	        testResults.append("Ran DecodeMG4ToTXT\n"); DecodeMG4ToTXT();
	        testResults.append("Ran DecodeMrSIDRaster\n"); DecodeMrSIDRaster();
	        testResults.append("Ran UserTest\n"); UserTest();
		} catch (Exception e) {
			allPassed = false;
			testResults.append("Exception:\n");
			testResults.append("  " + e.getMessage() + "\n");
		}
        
        if (allPassed == true) {
        	testResults.append("passed DSDK tests\n");
        }
        
		testResults.append("See LogCat for more detail\n");

        TextView  tv = new TextView(this);
        try {
			tv.setText(testResults.toString());
		} catch (Exception e) {
			e.printStackTrace();
			tv.setText(e.getMessage());
		}
        setContentView(tv);
    }

    public native void UserTutorial_iterator();
    public native void UserTutorial_read();
    public native void DumpMG4Info();
    public native void IterateOverPoints();
    public native void DecodeMG4ToTXT();
    public native void DecodeMrSIDRaster();
    public native void UserTest();

    
    static {
        System.loadLibrary("gnustl_shared");
        System.loadLibrary("lti_lidar_dsdk");
        System.loadLibrary("LidarExample");
    }
}
