package com.lizardtech.rasterexample;

import android.app.Activity;
import android.widget.TextView;
import android.os.Bundle;


public class RasterExample extends Activity
{
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        
        // Call the various SDK tests and report the results
        StringBuilder testResults = new StringBuilder();
        testResults.append(String.format("UserTest returned: %d\n", UserTest()));
        testResults.append(String.format("DecodeJP2ToBBB returned: %d\n", DecodeJP2ToBBB()));
        testResults.append(String.format("DecodeJP2ToJPG returned: %d\n", DecodeJP2ToJPG()));
        testResults.append(String.format("DecodeJP2ToMemory returned: %d\n", DecodeJP2ToMemory()));
        testResults.append(String.format("DecodeMrSIDBandSelection returned: %d\n", DecodeMrSIDBandSelection()));
        testResults.append(String.format("DecodeMrSIDLidar returned: %d\n", DecodeMrSIDLidar()));
        testResults.append(String.format("DecodeMrSIDToMemory returned: %d\n", DecodeMrSIDToMemory()));
        testResults.append(String.format("DecodeMrSIDToRaw returned: %d\n", DecodeMrSIDToRaw()));
        testResults.append(String.format("DecodeMrSIDToTIFF returned: %d\n", DecodeMrSIDToTIFF()));
        testResults.append(String.format("DecodeNITFToBBB returned: %d\n", DecodeNITFToBBB()));
        testResults.append(String.format("DerivedImageFilter returned: %d\n", DerivedImageFilter()));
        testResults.append(String.format("DerivedImageReader returned: %d\n", DerivedImageReader()));
        testResults.append(String.format("DerivedImageWriter returned: %d\n", DerivedImageWriter()));
        testResults.append(String.format("DerivedStream returned: %d\n", DerivedStream()));
        testResults.append(String.format("GeoScene returned: %d\n", GeoScene()));
        testResults.append(String.format("ImageInfo returned: %d\n", ImageInfo()));
        testResults.append(String.format("InterruptDelegate returned: %d\n", InterruptDelegate()));
        testResults.append(String.format("MetadataDump returned: %d\n", MetadataDump()));
        testResults.append(String.format("Pipeline returned: %d\n", Pipeline()));
        testResults.append(String.format("ProgressDelegate returned: %d\n", ProgressDelegate()));
        testResults.append(String.format("SceneBuffer returned: %d\n", SceneBuffer()));
        testResults.append(String.format("UsingCInterface returned: %d\n", UsingCInterface()));
        testResults.append(String.format("UsingCStream returned: %d\n", UsingCStream()));
        testResults.append(String.format("UsingStreams returned: %d\n", UsingStreams()));
        testResults.append(String.format("ErrorHandling returned: %d\n", ErrorHandling()));
        testResults.append("See LogCat for any non-zero returns\n");

        TextView  tv = new TextView(this);
        try {
			tv.setText(testResults.toString());
		} catch (Exception e) {
			e.printStackTrace();
			tv.setText(e.getMessage());
		}
        setContentView(tv);
    }

    public native int UserTest();
    public native int DecodeJP2ToBBB();
    public native int DecodeJP2ToJPG();
    public native int DecodeJP2ToMemory();
    public native int DecodeMrSIDBandSelection();
    public native int DecodeMrSIDLidar();
    public native int DecodeMrSIDToMemory();
    public native int DecodeMrSIDToRaw();
    public native int DecodeMrSIDToTIFF();
    public native int DecodeNITFToBBB();
    public native int DerivedImageFilter();
    public native int DerivedImageReader();
    public native int DerivedImageWriter();
    public native int DerivedStream();
    public native int ErrorHandling();
    public native int GeoScene();
    public native int ImageInfo();
    public native int InterruptDelegate();
    public native int MetadataDump();
    public native int Pipeline();
    public native int ProgressDelegate();
    public native int SceneBuffer();
    public native int UsingCInterface();
    public native int UsingCStream();
    public native int UsingStreams();
    
    static {
        System.loadLibrary("gnustl_shared");
        System.loadLibrary("ltidsdk");
        System.loadLibrary("RasterExample");
    }
}
